"use strict";

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

/* eslint no-param-reassign: ["error", { "props": false }] */

var Node = function Node(key) {
  _classCallCheck(this, Node);

  this.key = key;
  this.left = null;
  this.right = null;
};

var BinarySearchTree = function () {
  function BinarySearchTree() {
    _classCallCheck(this, BinarySearchTree);

    this.root = null;
  }

  _createClass(BinarySearchTree, [{
    key: "insert",
    value: function insert(key) {
      var node = new Node(key);
      if (!this.root) {
        this.root = node;
      } else {
        this.insertNode(this.root, node);
      }
    }
  }, {
    key: "insertNode",
    value: function insertNode(node, newNode) {
      if (newNode.key < node.key) {
        if (!node.left) {
          node.left = newNode;
        } else {
          this.insertNode(node.left, newNode);
        }
      } else if (!node.right) {
        node.right = newNode;
      } else {
        this.insertNode(node.right, newNode);
      }
    }
  }, {
    key: "inOrderTraverse",
    value: function inOrderTraverse(callback) {
      this.inOrderTraverseNode(this.root, callback);
    }
  }, {
    key: "inOrderTraverseNode",
    value: function inOrderTraverseNode(node, callback) {
      if (node !== null) {
        this.inOrderTraverseNode(node.left, callback);
        callback(node);
        this.inOrderTraverseNode(node.right, callback);
      }
    }
  }, {
    key: "preOrderTraverse",
    value: function preOrderTraverse(callback) {
      this.preOrderTraverseNode(this.root, callback);
    }
  }, {
    key: "preOrderTraverseNode",
    value: function preOrderTraverseNode(node, callback) {
      if (node !== null) {
        callback(node);
        this.preOrderTraverseNode(node.left, callback);
        this.preOrderTraverseNode(node.right, callback);
      }
    }
  }, {
    key: "postOrderTraverse",
    value: function postOrderTraverse(callback) {
      this.postOrderTraverseNode(this.root, callback);
    }
  }, {
    key: "postOrderTraverseNode",
    value: function postOrderTraverseNode(node, callback) {
      if (node !== null) {
        this.postOrderTraverseNode(node.left, callback);
        this.postOrderTraverseNode(node.right, callback);
        callback(node);
      }
    }
  }, {
    key: "min",
    value: function min() {
      var minimumNode = BinarySearchTree.minNode(this.root);
      if (minimumNode !== null) {
        return minimumNode.key;
      }
      return null;
    }
  }, {
    key: "max",
    value: function max() {
      var maximumNode = BinarySearchTree.maxNode(this.root);
      if (maximumNode !== null) {
        return maximumNode.key;
      }
      return null;
    }
  }, {
    key: "search",
    value: function search(key) {
      return this.searchNode(this.root, key);
    }
  }, {
    key: "searchNode",
    value: function searchNode(node, key) {
      if (node === null) {
        return false;
      }

      if (key < node.key) {
        return this.searchNode(node.left, key);
      } else if (key > node.key) {
        return this.searchNode(node.right, key);
      }

      return key === node.key;
    }
  }, {
    key: "remove",
    value: function remove(key) {
      this.root = this.removeNode(this.root, key);
    }
  }, {
    key: "removeNode",
    value: function removeNode(node, key) {
      var pointer = node;
      if (pointer === null) {
        return null;
      }

      if (key < pointer.key) {
        pointer.left = this.removeNode(pointer.left, key);
        return pointer;
      } else if (key > pointer.key) {
        pointer.right = this.removeNode(pointer.right, key);
        return pointer;
      } else if (key !== pointer.key) {
        // key value not exist in the tree
        return pointer;
      }

      if (pointer.left === null && pointer.right === null) {
        pointer = null;
        return pointer;
      }

      if (pointer.left === null) {
        pointer = pointer.right;
        return pointer;
      } else if (pointer.right === null) {
        pointer = pointer.left;
        return pointer;
      }

      var aux = BinarySearchTree.minNode(pointer.right);
      pointer.key = aux.key;
      pointer.right = this.removeNode(pointer.right, aux.key);
      return pointer;
    }
  }], [{
    key: "minNode",
    value: function minNode(node) {
      var pointer = node;
      if (pointer) {
        while (pointer && pointer.left !== null) {
          pointer = pointer.left;
        }
        return pointer;
      }
      return null;
    }
  }, {
    key: "maxNode",
    value: function maxNode(node) {
      var pointer = node;
      if (pointer) {
        while (pointer && pointer.right !== null) {
          pointer = pointer.right;
        }
        return pointer;
      }
      return null;
    }
  }]);

  return BinarySearchTree;
}();

module.exports = {
  BinarySearchTree: BinarySearchTree
};